package com.malk.mc.controller;

import com.alibaba.fastjson.JSONObject;
import com.malk.core.McProject;
import com.malk.mc.service.McProjectService;
import com.malk.server.common.McR;
import com.malk.utils.PublicUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/project/")
public class McProjectController {

    @Autowired
    private McProjectService mcProjectService;

    @PostMapping("add")
    public McR add(@RequestBody JSONObject param){
        if(PublicUtil.isNull(param,"projectId","appType","systemToken")){
            return McR.errorNullPointer();
        }
        McProject.addYida(param.getString("projectId"),new String[]{param.getString("appType"),param.getString("systemToken")});
        return McR.success(McProject.getYida(param.getString("projectId")));
    }

    @GetMapping("queryAll")
    public McR queryAll(){
        return McR.success(McProject.getYida());
    }

    @GetMapping("clear")
    public McR clear(){
        McProject.clearYida();
        return McR.success(McProject.getYida());
    }

    @GetMapping("init")
    public McR init(){
        mcProjectService.init();
        return McR.success(McProject.getYida());
    }


}
